import matplotlib.pyplot as plt
import cdt_path as cdt
import matplotlib.tri as tri

fig ,ax = plt.subplots(figsize=(14,8))

floor = {
    "vertices": [
        [
            0.2,
            0.4
        ],
        [
            13.2,
            0.4
        ],
        [
            13.2,
            -0.6
        ],
        [
            14.0,
            -0.6
        ],
        [
            14.0,
            0.4
        ],
        [
            28.0,
            0.4
        ],
        [
            28.0,
            2.1
        ],
        [
            24.0,
            2.1
        ],
        [
            24.0,
            6.7
        ],
        [
            28.0,
            6.7
        ],
        [
            28.0,
            8.4
        ],
        [
            0.2,
            8.4
        ],
        [
            0.2,
            6.7
        ],
        [
            3.4,
            6.7
        ],
        [
            3.4,
            6.5
        ],
        [
            0.2,
            6.5
        ],
        [
            0.2,
            2.3
        ],
        [
            3.4,
            2.3
        ],
        [
            3.4,
            2.1
        ],
        [
            0.2,
            2.1
        ],
        [
            4.2,
            2.1
        ],
        [
            8.0,
            2.1
        ],
        [
            8.0,
            4.7
        ],
        [
            7.0,
            4.7
        ],
        [
            7.0,
            6.0
        ],
        [
            8.0,
            6.0
        ],
        [
            8.0,
            6.7
        ],
        [
            4.2,
            6.7
        ],
        [
            4.2,
            4.4
        ],
        [
            6.0,
            4.4
        ],
        [
            6.0,
            2.3
        ],
        [
            4.2,
            2.3
        ],
        [
            9.3,
            2.1
        ],
        [
            22.3,
            2.1
        ],
        [
            22.3,
            6.7
        ],
        [
            13.3,
            6.7
        ],
        [
            13.3,
            6.5
        ],
        [
            14.0,
            6.5
        ],
        [
            14.0,
            4.8
        ],
        [
            13.4,
            4.8
        ],
        [
            13.4,
            4.6
        ],
        [
            14.0,
            4.6
        ],
        [
            14.0,
            2.7
        ],
        [
            12.0,
            2.7
        ],
        [
            12.0,
            4.6
        ],
        [
            12.6,
            4.6
        ],
        [
            12.6,
            4.8
        ],
        [
            12.0,
            4.8
        ],
        [
            12.0,
            6.7
        ],
        [
            9.3,
            6.7
        ],
        [
            9.3,
            6.5
        ],
        [
            11.0,
            6.5
        ],
        [
            11.0,
            2.3
        ],
        [
            9.3,
            2.3
        ]
    ],
    "segments": [
        [
            19,
            0
        ],
        [
            0,
            1
        ],
        [
            1,
            2
        ],
        [
            2,
            3
        ],
        [
            3,
            4
        ],
        [
            4,
            5
        ],
        [
            5,
            6
        ],
        [
            6,
            7
        ],
        [
            7,
            8
        ],
        [
            8,
            9
        ],
        [
            9,
            10
        ],
        [
            10,
            11
        ],
        [
            11,
            12
        ],
        [
            12,
            13
        ],
        [
            13,
            14
        ],
        [
            14,
            15
        ],
        [
            15,
            16
        ],
        [
            16,
            17
        ],
        [
            17,
            18
        ],
        [
            18,
            19
        ],
        [
            31,
            20
        ],
        [
            20,
            21
        ],
        [
            21,
            22
        ],
        [
            22,
            23
        ],
        [
            23,
            24
        ],
        [
            24,
            25
        ],
        [
            25,
            26
        ],
        [
            26,
            27
        ],
        [
            27,
            28
        ],
        [
            28,
            29
        ],
        [
            29,
            30
        ],
        [
            30,
            31
        ],
        [
            53,
            32
        ],
        [
            32,
            33
        ],
        [
            33,
            34
        ],
        [
            34,
            35
        ],
        [
            35,
            36
        ],
        [
            36,
            37
        ],
        [
            37,
            38
        ],
        [
            38,
            39
        ],
        [
            39,
            40
        ],
        [
            40,
            41
        ],
        [
            41,
            42
        ],
        [
            42,
            43
        ],
        [
            43,
            44
        ],
        [
            44,
            45
        ],
        [
            45,
            46
        ],
        [
            46,
            47
        ],
        [
            47,
            48
        ],
        [
            48,
            49
        ],
        [
            49,
            50
        ],
        [
            50,
            51
        ],
        [
            51,
            52
        ],
        [
            52,
            53
        ]
    ],
    "holes": [
        [
            6.5,
            2.4
        ],
        [
            9.4,
            2.2
        ]
    ]
}
cc  = cdt.triangulate(floor)

cdt.border.plot(ax, **cc)

triang = tri.Triangulation(cc['vertices'][:,0],cc['vertices'][:,1],cc['triangles'])

cdt.Interact(ax, triang, title=False)